---
title: Getting started with WebGL
slug: Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL
tags:
  - Tutorial
  - WebGL
---
<div>{{WebGLSidebar("Tutorial")}} {{Next("Web/API/WebGL_API/Tutorial/Adding_2D_content_to_a_WebGL_context")}}</div>

<p><span class="seoSummary"><a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> enables web content to use an API based on <a class="external" href="http://www.khronos.org/opengles/">OpenGL ES</a> 2.0 to perform 2D and 3D rendering in an HTML <a class="internal" href="/en-US/docs/Web/API/Canvas_API"><code>canvas</code></a> in browsers that support it without the use of plug-ins.</span> WebGL programs consist of control code written in JavaScript and shader code (GLSL) that is executed on a computer's Graphics Processing Unit (GPU). WebGL elements can be mixed with other HTML elements and composited with other parts of the page or page background.</p>

<p>This article will introduce you to the basics of using WebGL. It's assumed that you already have an understanding of the mathematics involved in 3D graphics, and this article doesn't pretend to try to teach you 3D graphics concepts itself.</p>

<p>The code examples in this tutorial can also be found in the <a href="https://github.com/mdn/webgl-examples/tree/gh-pages/tutorial">webgl-examples GitHub repository</a>.</p>

<p>It's worth noting here that this series of articles introduces WebGL itself; however, there are a number of frameworks available that encapsulate WebGL's capabilities, making it easier to build 3D applications and games, such as <a href="https://threejs.org/">THREE.js</a> and <a href="https://www.babylonjs.com/">BABYLON.js.</a></p>

<h2 id="Preparing_to_render_in_3D">Preparing to render in 3D</h2>

<p>The first thing you need in order to use WebGL for rendering is a canvas. The HTML fragment below declares a canvas that our sample will draw into.</p>

<pre class="brush: html notranslate">&lt;body&gt;
  &lt;canvas id="glCanvas" width="640" height="480"&gt;&lt;/canvas&gt;
&lt;/body&gt;
</pre>

<h3 id="Preparing_the_WebGL_context">Preparing the WebGL context</h3>

<p>The <code>main()</code> function in our JavaScript code, is called when our script is loaded. Its purpose is to set up the WebGL context and start rendering content.</p>

<pre class="brush: js notranslate">//
// start here
//
function main() {
  const canvas = document.querySelector("#glCanvas");
  // Initialize the GL context
  const gl = canvas.getContext("webgl");

  // Only continue if WebGL is available and working
  if (gl === null) {
    alert("Unable to initialize WebGL. Your browser or machine may not support it.");
    return;
  }

  // Set clear color to black, fully opaque
  gl.clearColor(0.0, 0.0, 0.0, 1.0);
  // Clear the color buffer with specified clear color
  gl.clear(gl.COLOR_BUFFER_BIT);
}

window.onload = main;

</pre>

<p>The first thing we do here is obtain a reference to the canvas, assigning it to a variable named <code>canvas</code>.</p>

<p>Once we have the canvas, we try to get a <code><a href="/en-US/docs/Web/API/WebGLRenderingContext">WebGLRenderingContext</a></code> for it by calling <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/getContext">getContext()</a></code> and passing it the string <code>"webgl"</code>. If the browser does not support WebGL, <code>getContext()</code> will return <code>null</code> in which case we display a message to the user and exit. </p>

<p>If the context is successfully initialized, the variable <code>gl</code> is our reference to it. In this case, we set the clear color to black, and clear the context to that color (redrawing the canvas with the background color).</p>

<p>At this point, you have enough code that the WebGL context should successfully initialize, and you should wind up with a big black, empty box, ready and waiting to receive content.</p>

<p>{{EmbedGHLiveSample('webgl-examples/tutorial/sample1/index.html', 670, 510) }}</p>

<p><a href="https://github.com/mdn/webgl-examples/tree/gh-pages/tutorial/sample1">View the complete code</a> | <a href="https://mdn.github.io/webgl-examples/tutorial/sample1/">Open this demo on a new page</a></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://dev.opera.com/articles/introduction-to-webgl-part-1/">An introduction to WebGL</a>: Written by Luz Caballero, published at dev.opera.com. This article addresses what WebGL is, explains how WebGL works (including the rendering pipeline concept), and introduces some WebGL libraries.</li>
 <li><a href="http://webglfundamentals.org/">WebGL Fundamentals</a></li>
 <li><a href="http://duriansoftware.com/joe/An-intro-to-modern-OpenGL.-Table-of-Contents.html">An intro to modern OpenGL:</a> A series of nice articles about OpenGL written by Joe Groff, providing a clear introduction to OpenGL from its history to the important graphics pipeline concept, and also includes some examples to demonstrate how OpenGL works. If you have no idea what OpenGL is, this is a good place to start.</li>
</ul>

<p>{{Next("Web/API/WebGL_API/Tutorial/Adding_2D_content_to_a_WebGL_context")}}</p>
